5

如果我跑

$#/bin/bash
for i in `seq 5`; do
    exec 3> >(sed -e "s/^/$i: /"; echo "$i-")
    echo foo >&3
    echo bar >&3
    exec 3>&-
done

那么结果不是同步的;它可能是这样的:

1: foo
1: bar
2: foo
2: bar
1-
3: foo
3: bar
2-
3-
4: foo
5: foo
4: bar
5: bar
4-
5-

如何确保>(...)在进行下一次迭代之前完成流程替换?

sleep 0.1在帮助之后插入exec 3>&-,但它不优雅,效率低下,并且不能保证始终有效。

编辑:这个例子可能看起来很傻,但这只是为了说明。我正在做的是在循环中读取输入流,将每一行馈送到一个在循环期间偶尔会发生变化的进程。在代码中更容易解释:

# again, simplified for illustration
while IFS= read line; do
    case $line in
    @*)
        exec 3>&-
        filename=${line:1}
        echo "starting $filename"
        exec 3> >(sort >"$filename"; echo "finished $filename")
        ;;
    *)
        echo "$line" >&3
        ;;
    esac
done
exec 3>&-
4

5 回答 5

5

以下工作在 bash 4 中,使用coprocesses

#!/bin/bash
fd_re='^[0-9]+$'
cleanup_and_wait() {
    if [[ ${COPROC[1]} =~ $fd_re ]] ; then
        eval "exec ${COPROC[1]}<&-"
        echo "waiting for $filename to finish" >&2
        wait $COPROC_PID
    fi
}

while IFS= read -r line; do
    case $line in
    @*)
        cleanup_and_wait
        filename=${line:1}
        echo "starting $filename" >&2
        coproc { sort >"$filename"; echo "Finished with $filename" >&2; }
        ;;
    *)
        printf '%s\n' "$line" >&${COPROC[1]}
        ;;
    esac
done
cleanup_and_wait

对于以前的 bash 版本,可以使用命名管道:

cleanup_and_wait() {
    if [[ $child_pid ]] ; then
      exec 4<&-
      echo "waiting for $filename to finish" >&2
      wait $child_pid
    fi
}

# this is a bit racy; without a force option to mkfifo,
# however, the race is unavoidable
fifo_name=$(mktemp -u -t fifo.XXXXXX)
if ! mkfifo "$fifo_name" ; then
  echo "Someone else may have created our temporary FIFO before we did!" >&2
  echo "This can indicate an attempt to exploit a race condition as a" >&2
  echo "security vulnarability and should always be tested for." >&2
  exit 1
fi

# ensure that we clean up even on unexpected exits
trap 'rm -f "$fifo_name"' EXIT

while IFS= read -r line; do
    case $line in
    @*)
        cleanup_and_wait
        filename=${line:1}
        echo "starting $filename" >&2
        { sort >"$filename"; echo "finished with $filename" >&2; } <"$fifo_name" &
        child_pid=$!
        exec 4>"$fifo_name"
        ;;
    *)
        printf '%s\n' "$line" >&4
        ;;
    esac
done
cleanup_and_wait

几点注意事项:

  • 使用起来printf '%s\n' "$line"echo "$line"; 例如,如果一行仅包含,则-e某些版本的echo不会对其执行任何操作。
  • 使用 EXIT 陷阱进行清理可确保意外的 SIGTERM 或其他错误不会留下陈旧的 fifo。
  • 如果您的平台提供了一种在单个原子操作中创建具有未知名称的 FIFO 的方法,请使用它;这将避免要求我们始终测试 mkfifo 是否成功的情况。
于 2012-06-21T03:09:12.440 回答
4

很简单,只需将所有内容都通过管道传输到 cat 中。

#!/bin/bash
for i in `seq 5`; do
  {
  exec 3> >(sed -e "s/^/$i: /"; echo "$i-")
  echo foo >&3
  echo bar >&3
  exec 3<&-
  }|cat
done

这是输出:

1: foo
1: bar
1-
2: foo
2: bar
2-
3: foo
3: bar
3-
4: foo
4: bar
4-
5: foo
5: bar
5-
于 2015-06-12T04:40:08.820 回答
3
mkfifo tmpfifo
for i in `seq 5`; do
  { sed -e "s/^/$i: /"; echo "$i-";} <tmpfifo &
  PID=$!
  exec 3> tmpfifo
  echo foo >&3
  echo bar >&3
  exec 3>&-
  wait $PID
done
rm tmpfifo
于 2012-06-21T09:37:57.483 回答
1

“显而易见”的答案是摆脱进程替换。

for i in `seq 5`; do
    echo foo | sed -e "s/^/$i: /"; echo "$i-"
    echo bar | sed -e "s/^/$i: /"; echo "$i-"
done

那么问题就变成了,你真的需要使用进程替换来构造你的代码吗?以上比尝试同步异步构造要简单得多。

于 2012-06-21T01:32:53.210 回答
0

另一个用户提出了同样的问题,并在此处收到了详尽的答案。

于 2018-07-11T20:32:39.050 回答